var _excluded = ["owner", "onChange", "disabled", "value", "size", "action", "fileUrlHandle", "resultHandle", "accept", "children", "style", "className", "uploadClassName", "itemRender", "itemRenderClick", "showOperationBtn", "id", "runLoading", "showUploadBtn", "showLoading"];

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect } from 'react';
import { useUpdateEffect, useLocalStorageState } from 'ahooks';
import { Upload, message, Button, Tooltip, Icon, Divider } from 'rlj-design';
import { PREFIX_CLS } from "../constants/dictionary";
import classnames from 'classnames';
import { LoadingOutlined } from '@ant-design/icons';
import PicturePreview from "./PicturePreview";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-AttachmentUpload");
var ACCEPT = '.pdf,.png,.JPG,.JPEG,.xlsx,.xls,.csv';

function isExcelFile(filename) {
  // 获取文件名的后缀
  var fileExtension = filename.split('.').pop().toLowerCase(); // 判断后缀是否是 Excel 文件的常见格式

  if (fileExtension === 'xlsx' || fileExtension === 'xls' || fileExtension === 'csv') {
    return true; // 是 Excel 文件
  }

  return false; // 不是 Excel 文件
}

var IMG_LIST = ['https://img.renlijia.com/202208/RLJvJ9a3riQ7Sg4e2JTdQ1xk2M-144-144.png', 'https://img.renlijia.com/202208/RLJV3E6mu6Mq7y2tnsdS02pJvI-144-144.png', 'https://img.renlijia.com/202307/RLJP003x144jcVlgHdId27uLJJ-144-144.png'];
export var AttachmentUpload = function AttachmentUpload(_ref) {
  var owner = _ref.owner,
      realOnChange = _ref.onChange,
      disabled = _ref.disabled,
      value = _ref.value,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 50 : _ref$size,
      action = _ref.action,
      fileUrlHandle = _ref.fileUrlHandle,
      resultHandle = _ref.resultHandle,
      accept = _ref.accept,
      children = _ref.children,
      style = _ref.style,
      className = _ref.className,
      uploadClassName = _ref.uploadClassName,
      itemRender = _ref.itemRender,
      itemRenderClick = _ref.itemRenderClick,
      _ref$showOperationBtn = _ref.showOperationBtn,
      showOperationBtn = _ref$showOperationBtn === void 0 ? true : _ref$showOperationBtn,
      id = _ref.id,
      runLoading = _ref.runLoading,
      showUploadBtn = _ref.showUploadBtn,
      _ref$showLoading = _ref.showLoading,
      showLoading = _ref$showLoading === void 0 ? true : _ref$showLoading,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(value || []),
      _useState2 = _slicedToArray(_useState, 2),
      files = _useState2[0],
      setFiles = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      loading = _useState4[0],
      setLoading = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      visible = _useState6[0],
      setVisible = _useState6[1];

  var _useState7 = useState(),
      _useState8 = _slicedToArray(_useState7, 2),
      curFile = _useState8[0],
      setCurFile = _useState8[1];

  var _useLocalStorageState = useLocalStorageState('Rlj-N', {
    serializer: function serializer(v) {
      return v;
    },
    deserializer: function deserializer(v) {
      return v;
    }
  }),
      _useLocalStorageState2 = _slicedToArray(_useLocalStorageState, 1),
      token = _useLocalStorageState2[0];

  var changeValue = function changeValue(value) {
    realOnChange && realOnChange(value);
  };

  useEffect(function () {
    value && setFiles(value);
  }, [value]);
  useUpdateEffect(function () {
    changeValue(files);
  }, [files]);

  var onChange = function onChange(_ref2) {
    var file = _ref2.file;
    if (file.size > ((size || 0) * 1000000 || 50000000)) return;

    switch (file.status) {
      case 'uploading':
        setLoading(true);
        break;

      case 'done':
        var res = resultHandle ? resultHandle(file) : file === null || file === void 0 ? void 0 : file.response;

        if ((res === null || res === void 0 ? void 0 : res.errorCode) !== null) {
          message.error((res === null || res === void 0 ? void 0 : res.errorMsg) || '上传失败');
        } else {
          var _res$data;

          var newFiles = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.files) || [];
          setFiles(restProps !== null && restProps !== void 0 && restProps.multiple ? files.concat(newFiles) : newFiles);
        }

        setLoading(false);
        break;

      default:
        setLoading(false);
        message.error('服务器错误');
        break;
    }
  };

  var getFileUrl = fileUrlHandle ? fileUrlHandle : function (state, curFile) {
    return "/rest/api/v1/oss/".concat(state, "?key=/").concat(owner, "/").concat(curFile === null || curFile === void 0 ? void 0 : curFile.time, "_").concat(curFile === null || curFile === void 0 ? void 0 : curFile.fileName, "&jwt=").concat(token);
  };

  var handleRemove = function handleRemove(index) {
    return function (e) {
      e.stopPropagation();
      setFiles(files === null || files === void 0 ? void 0 : files.filter(function (_, i) {
        return i !== index;
      }));
    };
  };

  var handlerPreview = function handlerPreview(item) {
    var _item$fileName;

    if (item !== null && item !== void 0 && (_item$fileName = item.fileName) !== null && _item$fileName !== void 0 && _item$fileName.includes('pdf')) {
      window.open(getFileUrl('preview', item));
    } else if (!isExcelFile(item === null || item === void 0 ? void 0 : item.fileName)) {
      setCurFile(item);
      setVisible(true);
    }
  };

  var beforeUpload = function beforeUpload(file) {
    if (file.size > ((size || 0) * 1000000 || 50000000)) {
      message.error("\u5355\u4E2A\u6587\u4EF6\u4E0D\u80FD\u8D85\u8FC7".concat(size, "M"));
      return false;
    }

    return true;
  };

  var getFileName = function getFileName(fileName) {
    var fileType = fileName.substring(fileName.lastIndexOf('.'), fileName.length);

    if (fileName.length > (fileType.toLowerCase() === 'jepg' ? 12 : 11)) {
      var frontText = fileName.substring(0, 6);
      var begindText = fileName.substring(fileName.lastIndexOf('.') - 1, fileName.length);
      var text = frontText + '...' + begindText;
      return text;
    }

    return fileName;
  };

  useEffect(function () {
    runLoading && runLoading(loading);
  }, [loading]);
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefixCls, className),
    style: style,
    id: id
  }, (!(files !== null && files !== void 0 && files.length) || restProps !== null && restProps !== void 0 && restProps.multiple || showUploadBtn) && !disabled ? /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefixCls, "-container"), uploadClassName)
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      opacity: loading && showLoading ? 0 : 1
    }
  }, /*#__PURE__*/React.createElement(Upload, _extends({
    className: "".concat(prefixCls, "-uploadComponent"),
    accept: accept || ACCEPT,
    action: action,
    data: {
      owner: owner
    },
    disabled: loading && showLoading,
    onChange: onChange,
    beforeUpload: beforeUpload,
    headers: token ? {
      'Rlj-N': token
    } : undefined
  }, restProps), children || /*#__PURE__*/React.createElement(Button, {
    type: "link",
    className: "".concat(prefixCls, "-uploadComponent-uploadButton"),
    stop: false,
    icon: /*#__PURE__*/React.createElement(Icon, {
      type: "upload"
    })
  }, "\u4E0A\u4F20"))), loading && showLoading && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-loading")
  }, /*#__PURE__*/React.createElement(LoadingOutlined, {
    style: {
      marginRight: 4
    }
  }), "\u4E0A\u4F20\u4E2D")) : !(files !== null && files !== void 0 && files.length) && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-noValue")
  }, "-"), files === null || files === void 0 ? void 0 : files.map(function (item, index) {
    var fileName = item.fileName,
        time = item.time;
    return itemRender ? /*#__PURE__*/React.createElement("span", {
      key: time || index,
      style: {
        display: 'inline-block'
      },
      onClick: function onClick() {
        return itemRenderClick ? itemRenderClick(getFileUrl('preview', item)) : handlerPreview(item);
      }
    }, itemRender(getFileUrl('preview', item))) : /*#__PURE__*/React.createElement("div", {
      key: time,
      className: "".concat(prefixCls, "-fileItem")
    }, /*#__PURE__*/React.createElement(Tooltip, {
      title: (fileName === null || fileName === void 0 ? void 0 : fileName.length) > 14 ? fileName : undefined
    }, /*#__PURE__*/React.createElement("div", {
      className: classnames("".concat(prefixCls, "-uploadFile"), _defineProperty({}, "".concat(prefixCls, "-uploadFileDisable"), disabled)),
      onClick: function onClick() {
        return handlerPreview(item);
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-uploadFile-uploadFileText")
    }, /*#__PURE__*/React.createElement("img", {
      src: fileName !== null && fileName !== void 0 && fileName.includes('.pdf') ? IMG_LIST[0] : isExcelFile(fileName) ? IMG_LIST[2] : IMG_LIST[1]
    }), /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-uploadFileText-uploadFileName")
    }, getFileName(fileName || ''))), !disabled && /*#__PURE__*/React.createElement(Icon, {
      type: "closeAreality",
      onClick: handleRemove(index),
      className: "".concat(prefixCls, "-uploadFile-removeButton")
    }))), disabled && showOperationBtn && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-operate")
    }, !isExcelFile(fileName) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
      type: "link",
      noPadding: true,
      disabled: false,
      onClick: function onClick() {
        return handlerPreview(item);
      },
      icon: /*#__PURE__*/React.createElement(Icon, {
        type: "display"
      })
    }, "\u9884\u89C8"), /*#__PURE__*/React.createElement(Divider, {
      type: "vertical"
    })), /*#__PURE__*/React.createElement(Button, {
      type: "link",
      noPadding: true,
      disabled: false,
      href: getFileUrl('download', item),
      icon: /*#__PURE__*/React.createElement(Icon, {
        type: "download"
      })
    }, "\u4E0B\u8F7D")));
  }), /*#__PURE__*/React.createElement(PicturePreview, {
    visible: visible,
    setVisible: setVisible,
    imgSrc: getFileUrl('download', curFile || {
      time: '',
      fileName: '',
      size: 0
    })
  }));
};
export default AttachmentUpload;