import React from 'react';
import { Button, Typography } from 'rlj-design';
import { PREFIX_CLS } from "../../../constants/dictionary";
import "./index.less";
var prefixCls = "".concat(PREFIX_CLS, "-scopeItem");
var prefixClsDetail = "".concat(PREFIX_CLS, "-scopeDetailWrapper");
export var ScopeDetail = function ScopeDetail(_ref) {
  var fields = _ref.fields;

  var getValue = function getValue(value) {
    return value === null || value === void 0 ? void 0 : value.map(function (item) {
      return typeof item === 'string' ? item : item.label;
    }).join('、');
  };

  return /*#__PURE__*/React.createElement("div", {
    className: prefixClsDetail
  }, fields === null || fields === void 0 ? void 0 : fields.map(function (_ref2, i) {
    var option = _ref2.option,
        value = _ref2.value;
    return /*#__PURE__*/React.createElement("span", {
      key: i
    }, /*#__PURE__*/React.createElement("span", null, i === 0 ? '当' : '且'), /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixClsDetail, "-scopeDetailText")
    }, "\u300C", (option === null || option === void 0 ? void 0 : option.fieldName) || (option === null || option === void 0 ? void 0 : option.label), "\uFF1A", getValue(value), "\u300D"));
  }), /*#__PURE__*/React.createElement("span", null, "\u65F6"));
};
export var ScopeOtherDetail = function ScopeOtherDetail(_ref3) {
  var list = _ref3.list;
  var TextOverFlow = Typography.TextOverFlow;
  return /*#__PURE__*/React.createElement("div", null, list.map(function (_ref4) {
    var code = _ref4.code,
        name = _ref4.name;
    return /*#__PURE__*/React.createElement(TextOverFlow, {
      key: code,
      width: "100%",
      style: {
        color: '#7f7f85'
      }
    }, name);
  }));
};
export var ScopeItem = function ScopeItem(_ref5) {
  var onClickChange = _ref5.onClickChange,
      disabled = _ref5.disabled,
      children = _ref5.children;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement("div", null, children), /*#__PURE__*/React.createElement(Button, {
    onClick: onClickChange,
    type: "link",
    disabled: disabled,
    noPadding: true,
    className: "".concat(prefixCls, "-scopeItemBtn")
  }, "\u4FEE\u6539")));
};