var _excluded = ["fun"],
    _excluded2 = ["key", "name"],
    _excluded3 = ["selection"],
    _excluded4 = ["selection"];

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useMemo } from 'react';
import { Input, Radio, Tag, Form, SelectCheckbox, Icon, Select, Button, Tooltip } from 'rlj-design';
import { useDebounceFn } from 'ahooks';
import { useStoreContext } from "../../hooks";
import { PREFIX_CLS } from "../../../constants/dictionary";
import DPSelect from "../../../Filter/components/DPSelect";
import CCSelect from "../../../Filter/components/CCSelect";
import "./index.less";
var Item = Form.Item;
var prefixCls = "".concat(PREFIX_CLS, "-scopeValue");
var prefixClsDropDown = "".concat(PREFIX_CLS, "-scopeValueDropDown"); // 这里写一个BaseWrapper容器让输入框能够接收到Form.Item给的props属性

var BaseWrapperHOC = function BaseWrapperHOC(_ref) {
  var fun = _ref.fun,
      restProps = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(React.Fragment, null, fun(restProps));
};

var ScopeValue = function ScopeValue(_ref2) {
  var item = _ref2.item,
      selected = _ref2.selected,
      setSelected = _ref2.setSelected,
      index = _ref2.index;

  var _useStoreContext = useStoreContext(),
      scopeFields = _useStoreContext.scopeFields,
      DDPickerProps = _useStoreContext.DDPickerProps,
      CCPickerProps = _useStoreContext.CCPickerProps,
      needShowSelectEmp = _useStoreContext.needShowSelectEmp;

  var _Form$useFormInstance = Form.useFormInstance(),
      setFieldValue = _Form$useFormInstance.setFieldValue,
      validateFields = _Form$useFormInstance.validateFields,
      getFieldValue = _Form$useFormInstance.getFieldValue;

  var key = item.key,
      name = item.name,
      restField = _objectWithoutProperties(item, _excluded2);

  var formListKey = [index, 'fields', name];

  var _useState = useState(getFieldValue(['scopeList'].concat(formListKey, ['option']))),
      _useState2 = _slicedToArray(_useState, 2),
      checkedData = _useState2[0],
      setCheckedData = _useState2[1];

  var _useState3 = useState(scopeFields || []),
      _useState4 = _slicedToArray(_useState3, 2),
      group = _useState4[0],
      setGroup = _useState4[1];

  var getFieldInfo = function getFieldInfo(fieldId) {
    var fieldInfo;
    scopeFields === null || scopeFields === void 0 ? void 0 : scopeFields.forEach(function (item) {
      item.fields.forEach(function (obj) {
        if (obj.fieldId === fieldId) {
          fieldInfo = obj;
          return;
        }
      });
    });
    return fieldInfo || {};
  };

  var _useMemo = useMemo(function () {
    if (!checkedData) return [];
    var fieldId = checkedData.fieldId;
    var fields = getFieldValue('scopeList')[index].fields;
    var realFields = fields === null || fields === void 0 ? void 0 : fields.filter(function (item) {
      return !!item;
    });
    if (!realFields.length) return;
    var temp = realFields === null || realFields === void 0 ? void 0 : realFields.map(function (_ref3) {
      var option = _ref3.option;
      return option === null || option === void 0 ? void 0 : option.fieldId;
    });
    setSelected(temp);
    return getFieldInfo(fieldId);
  }, [checkedData]),
      curSelection = _useMemo.selection;

  var _useDebounceFn = useDebounceFn(function (value) {
    if (!value) {
      setGroup(scopeFields);
      return;
    }

    var temp = [];
    scopeFields.forEach(function (_ref4) {
      var groupId = _ref4.groupId,
          groupName = _ref4.groupName,
          fields = _ref4.fields;
      var result = fields.filter(function (_ref5) {
        var fieldName = _ref5.fieldName;
        return fieldName.includes(value);
      });

      if (result.length) {
        temp.push({
          groupId: groupId,
          groupName: groupName,
          fields: result
        });
      }
    });
    setGroup(temp);
  }, {
    wait: 600
  }),
      searchValueChange = _useDebounceFn.run;

  var DP_SELECT_PROPS = {
    selectComProps: _objectSpread({
      getEffectDate: function getEffectDate() {
        return new Date();
      },
      multiple: true
    }, DDPickerProps),
    mode: 'multiple',
    maxTagCount: 2,
    maxTagTextLength: 6
  };
  var CC_SELECT_PROPS = {
    selectComProps: _objectSpread({
      multiple: false
    }, CCPickerProps)
  };
  var INPUT_COMPONENT = {
    string: function string() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return /*#__PURE__*/React.createElement(Select, _extends({
        mode: "tags",
        allowClear: true,
        placeholder: "\u8BF7\u8F93\u5165"
      }, props));
    },
    selection: function selection(_ref6) {
      var _ref6$selection = _ref6.selection,
          _selection = _ref6$selection === void 0 ? [] : _ref6$selection,
          restProps = _objectWithoutProperties(_ref6, _excluded3);

      return /*#__PURE__*/React.createElement(SelectCheckbox, _extends({
        maxTagCount: 2,
        maxTagTextLength: 6,
        options: _selection !== null && _selection !== void 0 && _selection.length ? _selection : curSelection,
        placeholder: "\u8BF7\u9009\u62E9"
      }, restProps));
    },
    object: function object(_ref7) {
      var _ref7$selection = _ref7.selection,
          selection = _ref7$selection === void 0 ? [] : _ref7$selection,
          props = _objectWithoutProperties(_ref7, _excluded4);

      return /*#__PURE__*/React.createElement(SelectCheckbox, _extends({
        maxTagCount: 2,
        maxTagTextLength: 6,
        options: selection !== null && selection !== void 0 && selection.length ? selection : curSelection,
        placeholder: "\u8BF7\u9009\u62E9"
      }, props));
    },
    org: function org() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return /*#__PURE__*/React.createElement(DPSelect, _extends({
        type: "dept"
      }, DP_SELECT_PROPS, {
        placeholder: "\u8BF7\u9009\u62E9"
      }, props));
    },
    emp: function emp() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return /*#__PURE__*/React.createElement(DPSelect, _extends({
        type: "person"
      }, DP_SELECT_PROPS, {
        placeholder: "\u8BF7\u9009\u62E9"
      }, props));
    },
    costCenter: function costCenter(props) {
      return /*#__PURE__*/React.createElement(CCSelect, _extends({}, CC_SELECT_PROPS, {
        placeholder: "\u8BF7\u9009\u62E9"
      }, props));
    }
  };

  var selectHandle = function selectHandle(option) {
    setFieldValue(['scopeList'].concat(formListKey, ['option']), option); // 切换字段时，清除右侧数据

    setFieldValue(['scopeList'].concat(formListKey, ['value']), undefined);
    setCheckedData(option);
    var index = checkedData !== null && checkedData !== void 0 && checkedData.fieldId ? selected.indexOf(checkedData === null || checkedData === void 0 ? void 0 : checkedData.fieldId) : -1;

    if (index > -1) {
      selected[index] = option.fieldId;
      setSelected(_toConsumableArray(selected));
    } else {
      setSelected(selected.concat(option.fieldId));
    }

    validateFields([['scopeList'].concat(formListKey, ['option'])]); // 手动清除一下选择框的focus状态

    if (document.activeElement instanceof HTMLElement) {
      document.activeElement.blur();
    }
  };

  var radioChange = function radioChange(e) {
    var value = e.target.value;
    selectHandle(value);
  };

  var getNoResultRender = function getNoResultRender() {
    return /*#__PURE__*/React.createElement("div", {
      className: "notFoundTips"
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "nodata",
      size: 64
    }), /*#__PURE__*/React.createElement("p", null, "\u641C\u7D22\u65E0\u7ED3\u679C"));
  };

  var selectPersonClick = function selectPersonClick() {
    selectHandle({
      fieldId: 'empId',
      fieldName: '员工',
      fieldType: 'emp',
      label: '员工',
      selection: null,
      value: 'empId',
      status: 'normal'
    });
  };

  var getDropdownRender = function getDropdownRender(originNode) {
    return /*#__PURE__*/React.createElement("div", {
      className: prefixClsDropDown
    }, needShowSelectEmp && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixClsDropDown, "-headerWrap")
    }, /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixClsDropDown, "-headerWrap-titleText")
    }, "\u82B1\u540D\u518C\u5B57\u6BB5"), /*#__PURE__*/React.createElement(Tooltip, {
      title: !!selected.length && !selected.includes('empId') && '人员不能和其他字段同时选择',
      placement: "topRight"
    }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Button, {
      disabled: !!selected.length && !selected.includes('empId'),
      onClick: selectPersonClick
    }, "\u9009\u62E9\u4EBA\u5458")))), /*#__PURE__*/React.createElement(Item, {
      style: {
        marginBottom: 0
      }
    }, /*#__PURE__*/React.createElement(Input.FillSearch, {
      style: {
        width: 436,
        marginLeft: 13
      },
      prefix: /*#__PURE__*/React.createElement(Icon, {
        type: "search"
      }),
      onChange: searchValueChange,
      placeholder: "\u641C\u7D22\u82B1\u540D\u518C\u5B57\u6BB5",
      allowClear: true
    })), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixClsDropDown, "-scopeValueMain")
    }, group !== null && group !== void 0 && group.length ? group.map(function (_ref8) {
      var groupId = _ref8.groupId,
          groupName = _ref8.groupName,
          fields = _ref8.fields;
      return /*#__PURE__*/React.createElement("div", {
        key: groupId
      }, /*#__PURE__*/React.createElement("p", {
        className: "".concat(prefixClsDropDown, "-scopeValueMain-radioTitle")
      }, groupName), fields === null || fields === void 0 ? void 0 : fields.map(function (_ref9) {
        var fieldId = _ref9.fieldId,
            fieldName = _ref9.fieldName,
            fieldType = _ref9.fieldType,
            status = _ref9.status,
            selection = _ref9.selection;
        var value = {
          fieldId: fieldId,
          fieldName: fieldName,
          fieldType: fieldType,
          selection: selection,
          value: fieldId,
          label: fieldName
        };
        var isChecked = selected.includes(fieldId);
        return /*#__PURE__*/React.createElement(Radio, {
          key: fieldId,
          value: value,
          className: "".concat(prefixClsDropDown, "-scopeValueMain-scopeValueRadio"),
          onChange: radioChange,
          disabled: isChecked,
          checked: isChecked
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            width: 120,
            display: 'flex'
          }
        }, /*#__PURE__*/React.createElement("p", null, fieldName), status === 'stop' && /*#__PURE__*/React.createElement(Tag, {
          style: {
            marginLeft: 4
          },
          type: "normal"
        }, "\u5DF2\u505C\u7528")));
      }));
    }) : originNode));
  };

  var getFun = function getFun(props) {
    return INPUT_COMPONENT[checkedData === null || checkedData === void 0 ? void 0 : checkedData.fieldType](_objectSpread({
      selection: (checkedData === null || checkedData === void 0 ? void 0 : checkedData.selection) || []
    }, props));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    key: key
  }, /*#__PURE__*/React.createElement(Item, _extends({}, restField, {
    name: [name, 'option'],
    rules: [{
      required: true,
      message: '请选择字段'
    }]
  }), /*#__PURE__*/React.createElement(Select, {
    placeholder: "\u8BF7\u9009\u62E9\u5B57\u6BB5",
    style: {
      width: 128,
      marginRight: 8
    },
    dropdownMatchSelectWidth: false,
    notFoundContent: getNoResultRender(),
    placement: "bottomLeft",
    dropdownRender: getDropdownRender,
    onClear: function onClear() {}
  })), /*#__PURE__*/React.createElement(Item, _extends({}, restField, {
    name: [name, 'value'],
    style: {
      width: 300
    },
    rules: [{
      required: !!(checkedData !== null && checkedData !== void 0 && checkedData.fieldId),
      message: '请选择或输入内容'
    }]
  }), checkedData !== null && checkedData !== void 0 && checkedData.fieldType ? /*#__PURE__*/React.createElement(BaseWrapperHOC, {
    fun: getFun
  }) : /*#__PURE__*/React.createElement(Input, {
    disabled: true
  })));
};

export default ScopeValue;