/// <reference types="react" />
export declare type CCItem = {
    label: string;
    value: string;
};
export interface CCNode extends CCItem {
    haveChildren: boolean;
    iconType: string;
    disabled: boolean;
    tooltip: string;
    code: string;
    status: 'disable' | 'enable';
    chain: string;
    children?: CCNode[];
}
export interface CCApiNode {
    nodeType: 3;
    costCenter: {
        costCenterChain: string;
        costCenterCode: string;
        costCenterId: string;
        costCenterStatus: string;
        name: string;
        expand: boolean;
    };
}
export interface CCApiNodeSearch {
    nodeType: 3;
    costCenterChain: string;
    costCenterCode: string;
    costCenterId: string;
    costCenterStatus: string;
    costCenterName: string;
}
export interface CCProps {
    /** 弹窗的显隐 */
    open: boolean;
    /** 是否多选 */
    multiple?: boolean;
    /** 指定当前选中的条目，多选时为一个数组 */
    value?: CCItem[];
    /** 点击确认的回调 */
    onOk: (param: CCItem[], keyList: (string | number)[], keyMap: Map<React.Key, CCApiNode>) => void;
    /** 点击取消回调 */
    onCancel: () => void;
    /** 搜索框默认文字 */
    searchPlaceholder?: string;
    /** 自定义请求参数 */
    defaultParams?: {
        [key: string]: any;
    };
    /** 是否包含下级 */
    recurse?: boolean;
    /** 禁止勾选节点 */
    disableNode?: {
        [key: string]: string;
    };
    /** 标题 */
    title?: string;
    /** 接口: 成本中心列表 */
    apiList: Function;
    /** 接口: 搜索成本中心 */
    apiSearch: Function;
    /** 是否显示更多 控制已经停用成本中心是否展示 */
    showMore?: boolean;
    /** 获取生效时间 */
    getEffectDate?: () => moment.Moment;
}
