import React, { ReactNode } from 'react';
import type { BaseTreeProps, BaseTreeNodeProps } from '../BaseTree';
export interface SearchParamsType {
    empIds?: React.Key[];
    effectDate?: string;
    searchKey?: string;
    orgIds?: React.Key[];
}
export interface PROPS {
    open: boolean;
    title?: string;
    type?: 'dept' | 'person';
    multiple?: boolean;
    selectDept: Function;
    searchDeptChain: Function;
    searchPersonChain: Function;
    onCancel: () => void;
    disableNode?: {
        [key: string]: string;
    };
    onOk: (param: {
        label: string;
        value: string;
    }[], keyList: (string | number)[], keyMap: Map<React.Key, BaseTreeNodeProps>) => void;
    value?: {
        label: string;
        value: string;
    }[];
    treeProps?: BaseTreeProps;
    customDataHandle?: (item: BaseTreeNodeProps) => {
        title: ReactNode;
        isLeaf: boolean;
        icon?: ReactNode | (() => ReactNode);
        checkable: boolean;
        nodeType: number;
        key: string;
        [key: string]: any;
    } & BaseTreeNodeProps;
    defaultParams?: {
        [key: string]: any;
    };
    searchPlaceholder?: string;
}
