function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import classnames from 'classnames';
import { Button } from 'rlj-design';
import { FieldSingleDrag } from "./components/FieldSingleDrag";
import { FieldMultipleDrag } from "./components/FieldMultipleDrag";
import { useStoreContext } from "./hooks";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/fieldDrag.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldDrag");

var FieldDrag = function FieldDrag(props) {
  var isDragGroup = props.isDragGroup,
      header = props.header,
      className = props.className,
      style = props.style;

  var _useStoreContext = useStoreContext(),
      fieldDragWidth = _useStoreContext.fieldDragWidth,
      isMultipleDragGroup = _useStoreContext.isMultipleDragGroup,
      setGroupSort = _useStoreContext.setGroupSort,
      groupSort = _useStoreContext.groupSort,
      groupDragable = _useStoreContext.groupDragable,
      dragable = _useStoreContext.dragable;

  var getHeaderRender = function getHeaderRender() {
    return header !== undefined ? header : /*#__PURE__*/React.createElement("p", null, "\u5DF2\u9009\u5B57\u6BB5", dragable && /*#__PURE__*/React.createElement("span", null, "\u53EF\u62D6\u62FD\u6807\u7B7E\u8C03\u6574\u987A\u5E8F"));
  };

  var getOperateBtnRender = function getOperateBtnRender() {
    return groupSort ? /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Button, {
      size: "small",
      onClick: function onClick() {
        return setGroupSort(false);
      }
    }, "\u53D6\u6D88"), /*#__PURE__*/React.createElement(Button, {
      type: "primary",
      size: "small",
      style: {
        marginLeft: 8
      },
      onClick: function onClick() {
        return setGroupSort(false);
      }
    }, "\u786E\u5B9A")) : groupDragable && /*#__PURE__*/React.createElement(Button, {
      type: "link",
      noPadding: true,
      onClick: function onClick() {
        return setGroupSort(true);
      }
    }, "\u5206\u7EC4\u6392\u5E8F");
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefixCls, className),
    style: _objectSpread({
      width: fieldDragWidth
    }, style)
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header")
  }, getHeaderRender(), isMultipleDragGroup && getOperateBtnRender()), isDragGroup ? /*#__PURE__*/React.createElement(FieldMultipleDrag, null) : /*#__PURE__*/React.createElement(FieldSingleDrag, null));
};

export default FieldDrag;