var _excluded = ["columns", "defaultSelectFields", "onOk", "fieldDragWidth", "fieldDragProps", "fieldCheckboxProps", "className", "watchSelectFields", "isMultipleDragGroup", "dragable", "groupDragable"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useImperativeHandle, forwardRef, useState } from 'react';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import { StoreContext, useMultipleDataHandle } from "./hooks";
import { useUpdateEffect } from 'ahooks';
import FieldCheckbox from "./FieldCheckbox";
import FieldDrag from "./FieldDrag";
import FieldSingleSetting from "./FieldSingleSetting";
import MultipleFieldsModal from "./MultipleFieldsModal";
import SingleFieldsModal from "./SingleFieldsModal";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldSetting");
var FieldSetting = /*#__PURE__*/forwardRef(function (props, ref) {
  var columns = props.columns,
      defaultSelectFields = props.defaultSelectFields,
      onOk = props.onOk,
      fieldDragWidth = props.fieldDragWidth,
      fieldDragProps = props.fieldDragProps,
      fieldCheckboxProps = props.fieldCheckboxProps,
      className = props.className,
      watchSelectFields = props.watchSelectFields,
      _props$isMultipleDrag = props.isMultipleDragGroup,
      isMultipleDragGroup = _props$isMultipleDrag === void 0 ? true : _props$isMultipleDrag,
      _props$dragable = props.dragable,
      dragable = _props$dragable === void 0 ? true : _props$dragable,
      _props$groupDragable = props.groupDragable,
      groupDragable = _props$groupDragable === void 0 ? true : _props$groupDragable,
      restProps = _objectWithoutProperties(props, _excluded);

  var data = useMultipleDataHandle(columns || [], isMultipleDragGroup);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      groupSort = _useState2[0],
      setGroupSort = _useState2[1];

  var selectFields = data.selectFields;

  var contextValue = _objectSpread({
    columns: columns,
    defaultSelectFields: defaultSelectFields,
    fieldDragWidth: fieldDragWidth,
    isMultipleDragGroup: isMultipleDragGroup,
    groupSort: groupSort,
    setGroupSort: setGroupSort,
    dragable: dragable,
    groupDragable: groupDragable
  }, data);

  useUpdateEffect(function () {
    watchSelectFields && watchSelectFields(selectFields);
  }, [selectFields]);
  useImperativeHandle(ref, function () {
    return {
      sortOk: sortOk,
      selectFields: selectFields
    };
  });

  var sortOk = function sortOk() {
    return onOk && onOk(selectFields);
  };

  return /*#__PURE__*/React.createElement(StoreContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("div", _extends({
    className: classnames(prefixCls, className)
  }, restProps), /*#__PURE__*/React.createElement(FieldCheckbox, _extends({
    isCheckboxGroup: true
  }, fieldCheckboxProps)), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-line")
  }), /*#__PURE__*/React.createElement(FieldDrag, _extends({
    isDragGroup: true
  }, fieldDragProps))));
});
FieldSetting.FieldSingleSetting = FieldSingleSetting;
FieldSetting.MultipleFieldsModal = MultipleFieldsModal;
FieldSetting.SingleFieldsModal = SingleFieldsModal;
export default FieldSetting;