var _excluded = ["open", "title", "loading", "onCancel", "cancelText", "okText", "columns", "defaultSelectFields", "fieldDragWidth", "fieldDragProps", "fieldCheckboxProps", "className", "modalProps"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useRef, useState } from 'react';
import { Modal, Button, Tooltip } from 'rlj-design';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import FieldSingleSetting from "./FieldSingleSetting";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-singleFieldsModal");
var PADDING = {
  style: {
    paddingTop: 16
  }
};

var SingleFieldsModal = function SingleFieldsModal(props) {
  var open = props.open,
      _props$title = props.title,
      title = _props$title === void 0 ? '字段设置' : _props$title,
      loading = props.loading,
      onCancel = props.onCancel,
      _props$cancelText = props.cancelText,
      cancelText = _props$cancelText === void 0 ? '取消' : _props$cancelText,
      _props$okText = props.okText,
      okText = _props$okText === void 0 ? '确定' : _props$okText,
      columns = props.columns,
      defaultSelectFields = props.defaultSelectFields,
      _props$fieldDragWidth = props.fieldDragWidth,
      fieldDragWidth = _props$fieldDragWidth === void 0 ? 390 : _props$fieldDragWidth,
      fieldDragProps = props.fieldDragProps,
      fieldCheckboxProps = props.fieldCheckboxProps,
      className = props.className,
      modalProps = props.modalProps,
      restProps = _objectWithoutProperties(props, _excluded);

  var ref = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      disabled = _useState2[0],
      setDisabled = _useState2[1];

  var watchSelectFields = function watchSelectFields(selectFields) {
    setDisabled(!(selectFields !== null && selectFields !== void 0 && selectFields.length));
  };

  var onOkClick = function onOkClick() {
    var _ref$current;

    (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.sortOk();
  };

  return /*#__PURE__*/React.createElement(Modal, _extends({
    title: title,
    width: 1015,
    open: open,
    onCancel: onCancel,
    destroyOnClose: true,
    footer: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
      onClick: onCancel,
      style: {
        marginRight: 8
      }
    }, cancelText), /*#__PURE__*/React.createElement(Tooltip, {
      title: disabled && '请至少选择一个字段'
    }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Button, {
      loading: loading,
      type: "primary",
      disabled: disabled,
      onClick: onOkClick
    }, okText))))
  }, modalProps, {
    className: classnames(prefixCls, modalProps === null || modalProps === void 0 ? void 0 : modalProps.className)
  }), /*#__PURE__*/React.createElement(FieldSingleSetting, _extends({
    ref: ref,
    columns: columns,
    defaultSelectFields: defaultSelectFields,
    fieldDragWidth: fieldDragWidth,
    fieldCheckboxProps: PADDING,
    fieldDragProps: PADDING,
    watchSelectFields: watchSelectFields
  }, restProps)));
};

export default SingleFieldsModal;