import React from 'react';
import type { FilterProps, FieldsType, ItemsMapType, FilterParamsType } from './interface';
import './style/index.less';
export declare const FilterContext: React.Context<({
    fields?: FieldsType | undefined;
    setFields: (selected: FieldsType) => void;
    filterOk: Function;
    itemsMap: Omit<ItemsMapType, 'filterOk'>;
    hasData: boolean;
    addFields?: FieldsType | undefined;
    onReset?: (() => void) | undefined;
} & Omit<FilterProps, "filterOk">) | null>;
export declare const valueHandle: (fieldId: string, value: any, express?: string) => FilterParamsType;
declare const Filter: {
    (props: FilterProps): JSX.Element;
    defaultProps: {
        trigger: string;
        btnText: string;
        unit: string;
        total: number;
        showSelectedTag: boolean;
        destroyTooltipOnHide: boolean;
    };
};
export default Filter;
