var _excluded = ["onSelect", "onSearch", "searchAction", "searchParams", "searchParamsHandle", "onChange", "optionRender"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useMemo } from 'react';
import { Spin, Select, Checkbox, Empty, Typography } from 'rlj-design';
import { useRequest } from 'ahooks';
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-personSelect");
var TextOverFlow = Typography.TextOverFlow;

var PersonSelect = function PersonSelect(_ref) {
  var onSelect = _ref.onSelect,
      onSearch = _ref.onSearch,
      searchAction = _ref.searchAction,
      _ref$searchParams = _ref.searchParams,
      searchParams = _ref$searchParams === void 0 ? {} : _ref$searchParams,
      searchParamsHandle = _ref.searchParamsHandle,
      onChange = _ref.onChange,
      optionRender = _ref.optionRender,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = useState(null),
      _useState4 = _slicedToArray(_useState3, 2),
      searchValue = _useState4[0],
      setSearchValue = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isShowNoData = _useState6[0],
      setIsShowNoData = _useState6[1];

  var _useState7 = useState([]),
      _useState8 = _slicedToArray(_useState7, 2),
      currentSelect = _useState8[0],
      setCurrentSelect = _useState8[1];

  var defaultSearchParamsHandle = function defaultSearchParamsHandle(data) {
    try {
      var _ref2 = data || {},
          list = _ref2.list;

      var newOptions = list === null || list === void 0 ? void 0 : list.map(function (item) {
        return _objectSpread(_objectSpread({}, item), {}, {
          label: item.name,
          value: item.empId,
          desc: item.parent_dept_chain
        });
      });
      return newOptions || [];
    } catch (error) {
      console.error(error);
    }

    return [];
  };

  var optionsMap = useMemo(function () {
    var tempMap = new Map();
    options === null || options === void 0 ? void 0 : options.forEach(function (item) {
      var value = item.value;
      tempMap.set(value, item);
    });
    return tempMap;
  }, [options]);
  var handle = useMemo(function () {
    return searchParamsHandle || defaultSearchParamsHandle;
  }, [searchParamsHandle]);

  var _useRequest = useRequest(searchAction, {
    manual: true,
    debounceWait: 500,
    loadingDelay: 300,
    onSuccess: function onSuccess(data) {
      var options = handle(data);
      setIsShowNoData(!(options !== null && options !== void 0 && options.length) && !!searchValue);
      setOptions(options);
    }
  }),
      getEmployee = _useRequest.run,
      loading = _useRequest.loading;

  var debounceFetcher = function debounceFetcher(value) {
    setSearchValue(value);

    if (onSearch) {
      onSearch(value, getEmployee);
      return;
    }

    if (!value) return;
    getEmployee(_objectSpread({
      fields: [{
        fieldId: 'name',
        value: value
      }]
    }, searchParams));
  };

  var comHandle = function comHandle(fun) {
    // 这里选择了人员之后放在.then中清除searchValue的值，因为立即清除的话会导致输入框显示的值有问题
    new Promise(function (resolve) {
      fun();
      resolve();
    }).then(function () {
      setSearchValue(null);
      (restProps === null || restProps === void 0 ? void 0 : restProps.mode) !== 'multiple' && setOptions([]);
    });
  };

  var optionHandle = function optionHandle(option) {
    var _ref3;

    return option ? (_ref3 = Array.isArray(option) ? option : [option]) === null || _ref3 === void 0 ? void 0 : _ref3.map(function (_ref4) {
      var label = _ref4.label,
          value = _ref4.value;
      return {
        label: label,
        value: value
      };
    }) : option;
  };

  var realOnChange = function realOnChange(_, option) {
    var newOption = optionHandle(option);
    setCurrentSelect(newOption === null || newOption === void 0 ? void 0 : newOption.map(function (item) {
      return item === null || item === void 0 ? void 0 : item.value;
    }));
    comHandle(function () {
      onChange && onChange(newOption, option, optionsMap);
    });
  };

  var realOnSelect = function realOnSelect(_, option) {
    comHandle(function () {
      onSelect && onSelect(optionHandle(option), option, optionsMap);
    });
  };

  return /*#__PURE__*/React.createElement(Select, _extends({
    showSearch: true,
    filterOption: false,
    onSearch: debounceFetcher,
    notFoundContent: loading ? /*#__PURE__*/React.createElement(Spin, {
      size: "small"
    }) : isShowNoData && /*#__PURE__*/React.createElement(Empty, {
      description: "\u6682\u65E0\u8BE5\u5458\u5DE5",
      image: Empty.PRESENTED_IMAGE_SIMPLE
    }),
    suffixIcon: null,
    placeholder: "\u8BF7\u8F93\u5165\u5458\u5DE5",
    onChange: realOnChange,
    onSelect: realOnSelect,
    onBlur: function onBlur() {
      setSearchValue(null);
      setOptions([]);
    },
    optionLabelProp: "label"
  }, restProps), options === null || options === void 0 ? void 0 : options.map(function (item) {
    var value = item.value,
        desc = item.desc,
        label = item.label,
        _item$employeeNumber = item.employeeNumber,
        employeeNumber = _item$employeeNumber === void 0 ? '' : _item$employeeNumber;
    return /*#__PURE__*/React.createElement(Select.Option, {
      key: value,
      value: value,
      label: label,
      className: "".concat(prefixCls, "-option")
    }, optionRender ? optionRender(item) : /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-option-item")
    }, (restProps === null || restProps === void 0 ? void 0 : restProps.mode) === 'multiple' && /*#__PURE__*/React.createElement(Checkbox, {
      checked: currentSelect.includes(value),
      className: "".concat(prefixCls, "-option-checkbox")
    }), /*#__PURE__*/React.createElement("span", {
      style: {
        display: 'inline-block',
        width: '100%'
      }
    }, typeof label === 'string' ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
      style: {
        display: 'inline-block',
        maxWidth: '65%'
      }
    }, /*#__PURE__*/React.createElement(TextOverFlow, null, label || '-')), /*#__PURE__*/React.createElement(TextOverFlow, {
      width: "30%",
      style: {
        marginLeft: 8,
        color: '#7f7f85',
        display: 'inline-block'
      }
    }, employeeNumber || '-')) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", null, label || '-'), /*#__PURE__*/React.createElement("span", {
      style: {
        marginLeft: 8,
        color: '#7f7f85'
      }
    }, employeeNumber || '-')), /*#__PURE__*/React.createElement("p", {
      className: "".concat(prefixCls, "-option-deptInfoClass")
    }, /*#__PURE__*/React.createElement(TextOverFlow, {
      width: "100%"
    }, desc || '-')))));
  }));
};

export default PersonSelect;