var _excluded = ["type", "data", "children", "fieldProps", "hidden"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useMemo } from 'react';
import { Popover, Tooltip } from 'rlj-design';

var PromptHoc = function PromptHoc(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'tooltip' : _ref$type,
      data = _ref.data,
      children = _ref.children,
      fieldProps = _ref.fieldProps,
      hidden = _ref.hidden,
      rest = _objectWithoutProperties(_ref, _excluded);

  var _findIndex = useMemo(function () {
    return data.findIndex(function (i) {
      return i.satisfy;
    });
  }, [data]); // 如果hidden为true返回空


  if (hidden && _findIndex !== -1) {
    return null;
  } // 查找不到直接返回原dom元素


  if (_findIndex === -1) {
    // return children;
    return /*#__PURE__*/React.cloneElement(children, _objectSpread({}, rest));
  }

  var isDisabled = data[_findIndex].disabled;

  var DisabledCom = function DisabledCom() {
    var _data$_findIndex$chil, _data$_findIndex, _children$props, _data$_findIndex$chil2, _data$_findIndex2;

    return isDisabled ? /*#__PURE__*/React.createElement("span", {
      style: {
        cursor: 'not-allowed',
        display: 'inline-block'
      }
    }, /*#__PURE__*/React.cloneElement(children, _objectSpread(_objectSpread(_objectSpread({}, rest), (_data$_findIndex$chil = (_data$_findIndex = data[_findIndex]) === null || _data$_findIndex === void 0 ? void 0 : _data$_findIndex.childrenProps) !== null && _data$_findIndex$chil !== void 0 ? _data$_findIndex$chil : {}), {}, {
      disabled: isDisabled,
      style: Object.assign({}, (_children$props = children.props) === null || _children$props === void 0 ? void 0 : _children$props.style, {
        pointerEvents: 'none'
      })
    }))) : /*#__PURE__*/React.cloneElement(children, _objectSpread(_objectSpread({}, rest), (_data$_findIndex$chil2 = (_data$_findIndex2 = data[_findIndex]) === null || _data$_findIndex2 === void 0 ? void 0 : _data$_findIndex2.childrenProps) !== null && _data$_findIndex$chil2 !== void 0 ? _data$_findIndex$chil2 : {}));
  }; // tooltip类型显示


  if (type === 'tooltip') {
    return /*#__PURE__*/React.createElement(Tooltip, _extends({
      title: data[_findIndex].text
    }, fieldProps), DisabledCom());
  } // popover类型显示


  if (type === 'popover') {
    return /*#__PURE__*/React.createElement(Popover, _extends({
      title: data[_findIndex].text
    }, fieldProps), DisabledCom());
  }

  return /*#__PURE__*/React.cloneElement(children, _objectSpread({}, rest));
};

export default PromptHoc;