/// <reference types="react" />
import type { SelectProps } from 'rlj-design';
import { Select } from 'rlj-design';
import type { RefSelectProps, DefaultOptionType } from 'rlj-design';
import type { Service, Options } from 'ahooks/lib/useRequest/src/types.d';
export interface SelectionItemType extends DefaultOptionType {
    label: React.ReactNode;
    value: React.Key;
    key?: React.Key;
    disabled?: boolean;
}
export interface SelectProProps extends SelectProps {
    optionsOrgin?: Service<any, [data: object]>;
    orginConfig?: Options<any, any> & {
        optionsDataHandle?: (data: any) => SelectProps['options'];
    };
    /** 自定义选项label展示 */
    labelRender?: (options: SelectionItemType) => React.ReactNode;
    fixedSizeListProps?: {
        height?: number;
        itemSize?: number;
        itemCoun?: number;
    };
}
export interface CompoundedComponent extends React.ForwardRefExoticComponent<SelectProProps & React.RefAttributes<RefSelectProps>> {
    SECRET_COMBOBOX_MODE_DO_NOT_USE: string;
    Option: typeof Select.Option;
    OptGroup: typeof Select.OptGroup;
}
