import { MutableRefObject } from 'react';
import type { TableProps, TableColumns, TableUnit, ISummation } from './index';
import { HtmlRefType, RenderModuleType } from './base';
import { ColDataType, ColumnInfoType, GridRefType } from './display';
import { ChangeTableTs } from './function';
export interface ISelectOneRow<T> {
    rowIndex: number;
    maxRowIndex: number;
    style: React.CSSProperties;
    currentData: T;
    currentColumn: TableColumns<T>;
}
export interface ReduxDataGenericsType<T> {
    loadingExpandId?: string;
    selectRow?: ISelectOneRow<T>;
    rowHeight?: number;
}
export declare type ReduxDataType = ReduxDataGenericsType<TableUnit>;
export interface ExcelContextGenericsType<T> extends ReduxDataGenericsType<T> {
    crosswalk?: boolean;
    defaultShowCtx?: string;
    expandConfig: TableProps<T>['expandConfig'];
    editableConfig: TableProps<T>['editableConfig'];
    modalRef: MutableRefObject<HtmlRefType>;
    excelBox: MutableRefObject<HtmlRefType>;
    dragLine: MutableRefObject<HtmlRefType>;
    gridRef: MutableRefObject<GridRefType>;
    moveLine: MutableRefObject<HtmlRefType>;
    leftLine: MutableRefObject<HtmlRefType>;
    rightLine: MutableRefObject<HtmlRefType>;
    salaryBox: MutableRefObject<HtmlRefType>;
    renderModule?: RenderModuleType;
    colData: ColDataType;
    columnInfo: ColumnInfoType;
    dataSource: T[];
    summation?: ISummation<T>;
    width: number;
    height: number;
    rowKey: string;
    rowSelection: TableProps<T>['rowSelection'];
    changeTable: ChangeTableTs;
    changeColumns: (index: number, childIndex: number, value: any, type: string) => void;
}
export declare type ExcelContextType = ExcelContextGenericsType<TableUnit>;
export interface DataContextType {
    [key: string]: any;
    columnWidth: (index: number) => number;
    rowHeight: (index: number) => number;
    changeRedux: (param: any) => void;
}
