import React, { useContext } from 'react';
import { getRowKeys } from "../../../utils/tools";
import Item from "../item";
import { ExcelContext } from "../../../index";
import "./index.less"; // 网格，表格中没有fixed的内容

var GridColumn = function GridColumn(props) {
  var rowIndex = props.rowIndex,
      style = props.style,
      columnIndex = props.columnIndex;
  var excelCtx = useContext(ExcelContext);
  var _excelCtx$rowKey = excelCtx.rowKey,
      rowKey = _excelCtx$rowKey === void 0 ? 'id' : _excelCtx$rowKey,
      columnInfo = excelCtx.columnInfo,
      dataSource = excelCtx.dataSource;
  var currentColumn = columnInfo.noFixed.data[columnIndex];
  var currentData = dataSource[rowIndex];
  return /*#__PURE__*/React.createElement("div", {
    style: style
  }, /*#__PURE__*/React.createElement(Item, {
    key: getRowKeys(rowKey, currentData) + currentColumn.dataIndex,
    rowIndex: rowIndex,
    columnIndex: columnIndex,
    currentData: currentData,
    currentColumn: currentColumn,
    style: style
  }));
};

export default GridColumn;