import React, { useEffect, useRef, useContext } from 'react';
import { sumWidths } from "../../utils/tools";
import { Icon } from 'rlj-design';
import classnames from 'classnames';
import "./index.less";
import { ExcelContext } from "../../index";
export default function Footer() {
  var touchBottom = useRef({
    flag: false,
    preValue: 0
  });

  var _ref = useContext(ExcelContext),
      editableConfig = _ref.editableConfig,
      gridRef = _ref.gridRef,
      columnInfo = _ref.columnInfo,
      colData = _ref.colData,
      changeTable = _ref.changeTable;

  var _ref2 = editableConfig || {},
      editable = _ref2.editable,
      showAddBtn = _ref2.showAddBtn;

  var height = colData.defaultItemHeight;

  var isEndBottom = function () {
    var isShowDirScrollBar = columnInfo.isShowDirScrollBar,
        dataSourceHeightInfo = columnInfo.dataSourceHeightInfo,
        contHeight = columnInfo.contHeight;
    var len = sumWidths(dataSourceHeightInfo);
    var maxHeight = len * height;
    var scrollTop = maxHeight - contHeight;

    if (isShowDirScrollBar) {
      if (gridRef.current && scrollTop === gridRef.current.state.scrollTop) {
        return true;
      } else {
        return false;
      }
    } else {
      return true;
    }
  }();

  useEffect(function () {
    var dataSourceHeightInfo = columnInfo.dataSourceHeightInfo,
        contHeight = columnInfo.contHeight;
    var len = sumWidths(dataSourceHeightInfo);
    if (touchBottom.current.preValue === len) return;
    touchBottom.current.preValue = len;

    if (touchBottom.current.flag) {
      var _gridRef$current;

      var maxHeight = len * height;
      var scrollTop = maxHeight - contHeight;
      (_gridRef$current = gridRef.current) === null || _gridRef$current === void 0 ? void 0 : _gridRef$current.scrollTo({
        scrollLeft: 0,
        scrollTop: scrollTop
      });
      touchBottom.current.flag = false;
    }
  }, [columnInfo, touchBottom]);

  if (editable && showAddBtn) {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        height: height
      },
      className: classnames('salaryExcelStickyRowFooterBox', {
        salaryExcelStickyRowFooterBoxBottom: isEndBottom
      })
    }, /*#__PURE__*/React.createElement("div", {
      className: "rowFooterBoxInner",
      style: {
        width: columnInfo.curMaxWidth
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "rowFooterAddBtn",
      onClick: function onClick() {
        touchBottom.current.flag = true; // @ts-ignore;

        changeTable({}, 'addOneData');
      }
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "add"
    }), /*#__PURE__*/React.createElement("span", null, "\u6DFB\u52A0"))));
  } else {
    return null;
  }
}