function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { infoWidth, foldWidth, maxHeight as inSideMaxHeight, minItemWidth, sorterWidth, extraIconWidth, foldKeySuffix } from "./config";
// 获取表头唯一key
export var getKey = function getKey() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      dataIndex = _ref.dataIndex,
      key = _ref.key;

  return dataIndex || key;
}; // 通过入参的rowKey获取指定的值

export var getRowKeys = function getRowKeys(rowKey, v) {
  return typeof rowKey === 'function' ? rowKey(v) : v[rowKey];
}; // reduce计算一个number数组的sum（和）

export var sumWidths = function sumWidths(source) {
  if (source.length) {
    return source.reduce(function (prev, current) {
      return prev + current;
    });
  } else {
    return 0;
  }
}; // 获取所有的字段的宽度数组, 只做2层结构; 子菜单合并到一个，如果没有给width，就用默认值defaultItemHeight

export var getWidths = function getWidths() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var colData = arguments.length > 1 ? arguments[1] : undefined;
  var defaultItemWidth = colData.defaultItemWidth;
  return value.map(function (column) {
    if (column.children) {
      return sumWidths(column.children.map(function (_ref2) {
        var width = _ref2.width;
        return width || defaultItemWidth;
      }));
    } else {
      return column.width || defaultItemWidth;
    }
  });
}; // 获取滚动条的宽度

var _getScrollbarWidth = function getScrollbarWidth() {
  var outer = document.createElement('div');
  outer.style.visibility = 'hidden';
  outer.style.overflow = 'scroll';
  document.body.appendChild(outer);
  var inner = document.createElement('div');
  outer.appendChild(inner);
  var scrollbarWidth = outer.offsetWidth - inner.offsetWidth;
  outer.parentNode.removeChild(outer);

  _getScrollbarWidth = function getScrollbarWidth() {
    return scrollbarWidth;
  };

  return scrollbarWidth;
}; // 获取显示区域的坐标范围


export { _getScrollbarWidth as getScrollbarWidth };
export var getRenderedCursor = function getRenderedCursor(children) {
  return children.reduce(function (_ref3, _ref4) {
    var _ref5 = _slicedToArray(_ref3, 4),
        minRow = _ref5[0],
        maxRow = _ref5[1],
        minColumn = _ref5[2],
        maxColumn = _ref5[3];

    var _ref4$props = _ref4.props,
        columnIndex = _ref4$props.columnIndex,
        rowIndex = _ref4$props.rowIndex;

    if (rowIndex < minRow) {
      minRow = rowIndex;
    }

    if (rowIndex > maxRow) {
      maxRow = rowIndex;
    }

    if (columnIndex < minColumn) {
      minColumn = columnIndex;
    }

    if (columnIndex > maxColumn) {
      maxColumn = columnIndex;
    }

    return [minRow, maxRow, minColumn, maxColumn];
  }, [Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY, Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY]);
}; // 浅拷贝

function clone(sourceS) {
  return sourceS.map(function (v) {
    var item = _objectSpread({}, v);

    if (v.children) {
      item.children = v.children.map(function (vv) {
        return _objectSpread({}, vv);
      });
    }

    return item;
  });
} // 处理表头数据, 合并单元格，计算宽度，设置宽度默认值等


export var columnsFn = function columnsFn(params) {
  var columnsWithHide = params.columns,
      dataSourceHide = params.dataSource,
      rowSelection = params.rowSelection,
      width = params.width,
      maxHeight = params.maxHeight,
      colData = params.colData,
      expandConfig = params.expandConfig,
      summation = params.summation,
      editableConfig = params.editableConfig,
      _params$rowKey = params.rowKey,
      rowKey = _params$rowKey === void 0 ? 'id' : _params$rowKey;

  var _ref6 = expandConfig || {},
      expandKey = _ref6.expandKey;

  var _ref7 = editableConfig || {},
      showColExtraHeader = _ref7.showColExtraHeader,
      showRowExtraHeader = _ref7.showRowExtraHeader,
      editable = _ref7.editable,
      showAddBtn = _ref7.showAddBtn; // 二级表头如果想要吸附，则需要先取出来，根据fixed的值，left和right，放到数组的前面和后面


  var getSubColumnsFixed = function getSubColumnsFixed() {
    var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var sourceS = clone(source);

    var addFoldInfo = function addFoldInfo(item, index, all) {
      var _all, _all3, _item$children;

      if (item.hidden && ((_all = all[index - 1]) === null || _all === void 0 ? void 0 : _all.hidden) === undefined) {
        var _all2;

        item.foldInfo = {
          baseKey: getKey(item) + foldKeySuffix,
          firstCol: true,
          lastCol: ((_all2 = all[index + 1]) === null || _all2 === void 0 ? void 0 : _all2.hidden) === undefined
        };
      }

      if (item.hidden && (_all3 = all[index - 1]) !== null && _all3 !== void 0 && _all3.hidden) {
        var _all4, _all4$foldInfo, _all5;

        item.foldInfo = {
          baseKey: (_all4 = all[index - 1]) === null || _all4 === void 0 ? void 0 : (_all4$foldInfo = _all4.foldInfo) === null || _all4$foldInfo === void 0 ? void 0 : _all4$foldInfo.baseKey,
          firstCol: false,
          lastCol: ((_all5 = all[index + 1]) === null || _all5 === void 0 ? void 0 : _all5.hidden) === undefined
        };
      }

      if (!(item !== null && item !== void 0 && (_item$children = item.children) !== null && _item$children !== void 0 && _item$children.length)) {
        delete item.children;
      }

      if (item !== null && item !== void 0 && item.required && !(item !== null && item !== void 0 && item.minWidth)) {
        item.minWidth = 42;
      }
    };

    var resLeft = [],
        res = [],
        resRight = [];
    sourceS.forEach(function (v, index) {
      var _v$children;

      if (!!(v !== null && v !== void 0 && (_v$children = v.children) !== null && _v$children !== void 0 && _v$children.length)) {
        // 有children
        var hasFixedChild = v.children.filter(function (vv) {
          return ['left', 'right'].includes(vv.fixed || '');
        });
        var noFixedChild = v.children.filter(function (vv) {
          return !['left', 'right'].includes(vv.fixed || '');
        });
        noFixedChild.forEach(function (vv, index) {
          vv.father = {
            data: v,
            index: index,
            firstCol: index === 0,
            lastCol: index + 1 === noFixedChild.length
          };

          if (vv.valueType === 'file') {
            vv.resize = false;
            vv.width = 213;
          }

          addFoldInfo(vv, index, noFixedChild !== null && noFixedChild !== void 0 ? noFixedChild : []);
          res.push(vv);
        });
        hasFixedChild.forEach(function (vv, index) {
          if (vv.valueType === 'file') {
            vv.resize = false;
            vv.width = 213;
          }

          addFoldInfo(vv, index, hasFixedChild !== null && hasFixedChild !== void 0 ? hasFixedChild : []);

          if (vv.fixed === 'left') {
            resLeft.push(vv);
          } else if (vv.fixed === 'right') {
            resRight.push(vv);
          }
        });
      } else {
        if (v.valueType === 'file') {
          v.resize = false;
          v.width = 213;
        }

        addFoldInfo(v, index, sourceS); // 无children

        if (v.fixed === 'left') {
          resLeft.push(v);
        } else if (v.fixed === 'right') {
          resRight.push(v);
        } else {
          res.push(v);
        }
      }
    });
    return [].concat(resLeft, res, resRight);
  }; // 新隐藏场景，单纯地隐藏字段，没有折叠展开的功能 => 隐藏关键字段是show


  var removeShowCol = function removeShowCol() {
    var sourceS = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var source = clone(sourceS);
    return source.filter(function (item) {
      var _item$children2;

      if ((_item$children2 = item.children) !== null && _item$children2 !== void 0 && _item$children2.length) {
        var tmp = item.children.filter(function (v) {
          return v.show !== false;
        });

        if (tmp !== null && tmp !== void 0 && tmp.length) {
          item.children = tmp;
        } else {
          delete item.children;
        }
      }

      return item.show !== false;
    });
  }; // 把隐藏字段从数组中去除 => 只适用于二级表头的隐藏 => 隐藏的关键字段是hidden


  var removeHideCol = function removeHideCol() {
    var sourceS = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var source = clone(sourceS);
    return source.reduce(function (res, item) {
      var _item$foldInfo;

      if (colData.fold[(_item$foldInfo = item.foldInfo) === null || _item$foldInfo === void 0 ? void 0 : _item$foldInfo.baseKey] === false) {
        var _item$foldInfo2;

        if ((_item$foldInfo2 = item.foldInfo) !== null && _item$foldInfo2 !== void 0 && _item$foldInfo2.lastCol) {
          item.fold = false;
        }

        return res.concat(item);
      }

      if (item.hidden) {
        var _item$foldInfo3, _item$foldInfo4;

        colData.fold[item === null || item === void 0 ? void 0 : (_item$foldInfo3 = item.foldInfo) === null || _item$foldInfo3 === void 0 ? void 0 : _item$foldInfo3.baseKey] = true;

        if (item !== null && item !== void 0 && (_item$foldInfo4 = item.foldInfo) !== null && _item$foldInfo4 !== void 0 && _item$foldInfo4.firstCol) {
          var _item$foldInfo5;

          return res.concat({
            title: '',
            dataIndex: item === null || item === void 0 ? void 0 : (_item$foldInfo5 = item.foldInfo) === null || _item$foldInfo5 === void 0 ? void 0 : _item$foldInfo5.baseKey,
            resize: false,
            width: 16,
            father: item.father,
            fold: true,
            foldInfo: {
              baseKey: item.foldInfo.baseKey,
              firstCol: false,
              lastCol: false
            }
          });
        } else {
          return res;
        }
      }

      return res.concat(item);
    }, []);
  }; // 设置排序字段，先分开写吧，写在一起感觉很乱，性能有问题的话，后续可以优化


  var addSortStatus = function addSortStatus() {
    var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return source.map(function (v) {
      if (v.sorter && colData.sort.key === getKey(v)) {
        v.sortOrder = colData.sort.value;
      }

      return v;
    });
  };

  var defaultItemWidth = colData.defaultItemWidth; // 添加默认宽度by width, 这个with需要提前处理好滚动条的宽度；返回是否有滚动条

  var addDefaultWidth = function addDefaultWidth(source, width) {
    var fn = function fn(w1, w2) {
      var lastIndex = -1; // 从最后开始遍历，找到最后第一个没有设置宽度的列，取出索引

      for (var i = source.length - 1; i >= 0; i--) {
        if (colData.width[getKey(source[i])]) {
          source[i].width = colData.width[getKey(source[i])];
          continue;
        }

        if (!source[i].width) {
          var curWidth = w1;

          if (lastIndex < 0) {
            lastIndex = i;
            curWidth = w2;
          }

          source[i].width = curWidth;

          if (getKey(source[i])) {
            colData.width[getKey(source[i])] = curWidth;
          }
        } else {
          if (getKey(source[i])) {
            colData.width[getKey(source[i])] = source[i].width;
          }
        }
      }
    }; // 计算没有宽度的列的数量


    var colNoWidthNum = sumWidths(source.map(function (v) {
      if (v.children) {
        var tmp = v.children.filter(function (v) {
          return !v.width;
        });
        return tmp.length;
      } else {
        return v.width ? 0 : 1;
      }
    }));
    var lenCol = sumWidths(getWidths(source, colData));

    if (lenCol < width) {
      // 使用默认宽度，不能完全填充满
      var assist1 = (width - lenCol) / colNoWidthNum;
      var assist2 = Math.floor(assist1); //向下取整的值

      var normalW = defaultItemWidth + assist2;
      var lastW = normalW;

      if (assist1 !== assist2) {
        // 如果两者不相等，则总实际宽度必定不够
        lastW += width - (lenCol + assist2 * colNoWidthNum);
      }

      fn(normalW, lastW);
      return sumWidths(getWidths(source, colData)) > width; // 返回false，代表没有横向滚动条
    } else {
      fn(defaultItemWidth, defaultItemWidth);
      return lenCol !== width; // 返回true, 代表有横向滚动条
    }
  }; // 获取表头层数高度


  var getHierarchy = function getHierarchy(source) {
    for (var i = 0; i < source.length; i++) {
      var children = source[i].children;

      if (children && children.length) {
        return 2;
      }
    }

    return 1;
  }; // 递归dataSource


  var getDataSource = function getDataSource(param) {
    var source = clone(param);

    var _ref8 = colData || {},
        _ref8$deleteDataRowId = _ref8.deleteDataRowIdArr,
        deleteDataRowIdArr = _ref8$deleteDataRowId === void 0 ? [] : _ref8$deleteDataRowId,
        _ref8$addDataRowIdArr = _ref8.addDataRowIdArr,
        addDataRowIdArr = _ref8$addDataRowIdArr === void 0 ? [] : _ref8$addDataRowIdArr;

    source.push.apply(source, _toConsumableArray(addDataRowIdArr));
    var res = [];
    var heightInfo = [];

    var fn = function fn(source, index) {
      source.forEach(function (v) {
        var expandStatus = colData.expand.includes(v[expandKey]);
        v.children = (v.children || []).length ? v.children : colData.expandData[v[expandKey]] || [];
        res.push(_objectSpread(_objectSpread(_objectSpread({}, v), colData.changeDataSource[getRowKeys(rowKey, v)]), {}, {
          hierarchy: index,
          expandStatus: expandStatus
        }));

        if (expandStatus && v.children && Object.prototype.toString.call(v.children) === '[object Array]' && v.children.length) {
          fn(v.children, index + 1);
        }
      });
    };

    fn(source, 1);
    res = res.filter(function (v) {
      return !deleteDataRowIdArr.includes(getRowKeys(rowKey, v));
    });
    res.forEach(function (_, i) {
      heightInfo[i] = 1;
    });

    if (res.length === 0) {
      return [[{}], [1], true];
    } else {
      return [res, heightInfo, false];
    }
  }; // 最大高度，可能表格有高度限制的入参, 这只是内容的高度，本身是内容+表头+底部添加按钮等
  // 最后在这个高度的基础上，加上滚动条，就可以渲染的最大高度


  var curMaxHeight = maxHeight || inSideMaxHeight;
  var columns = addSortStatus(removeHideCol(getSubColumnsFixed(removeShowCol(columnsWithHide)))); //移除隐藏项

  columns[0].firstCol = true;

  if (rowSelection) {
    columns.unshift({
      dataIndex: 'rowSelection',
      title: 'rowSelectionChecked',
      fixed: 'left',
      width: rowSelection.rowSelectionIconSp ? 56 : 37,
      rowSelectionIconSp: rowSelection.rowSelectionIconSp
    });
  }

  if (editable && showRowExtraHeader !== false) {
    columns.unshift({
      dataIndex: 'rowPrefixSp',
      title: '',
      fixed: 'left',
      width: 50
    });
  } // 给最后一列打个标, 最后一列没有右边框


  columns[columns.length - 1].lastCol = true;

  var _getDataSource = getDataSource(dataSourceHide),
      _getDataSource2 = _slicedToArray(_getDataSource, 3),
      dataSource = _getDataSource2[0],
      dataSourceHeightInfo = _getDataSource2[1],
      isEmptyData = _getDataSource2[2];

  var hierarchy = getHierarchy(columnsWithHide); //获取表头深度

  var defaultItemHeight = colData.defaultItemHeight;
  var hierarchyHeight = defaultItemHeight * hierarchy + (editable && showColExtraHeader !== false ? defaultItemHeight : 0); //计算表头高度

  var dataSourceLen = sumWidths(dataSourceHeightInfo);

  if (isEmptyData) {
    dataSourceLen = 0;
  }

  var addBtnHeight = editable && showAddBtn ? defaultItemHeight : 0;
  var summationHeight = summation !== null && summation !== void 0 && summation.show ? defaultItemHeight : 0;
  var dataSourceHeight = dataSourceLen * defaultItemHeight; //计算数据的高度

  var curHeight = hierarchyHeight + dataSourceHeight + addBtnHeight + summationHeight; //总高度

  var isShowDirScrollBar = false; //是否显示纵向滚动条，会影响表头实际宽度的计算

  if (curMaxHeight < curHeight) {
    isShowDirScrollBar = true; //实际内容比最大高度高，此时会有纵向滚动条
  } else {
    curMaxHeight = curHeight;
  }

  var curMaxWidth = width - (isShowDirScrollBar ? _getScrollbarWidth() : 0); //最大可用显示宽度，这个是不包括滚动条的

  var isShowCrossScrollBar = addDefaultWidth(columns, curMaxWidth); //给没有添加宽度的列补上一个默认宽度, 返回是否有横向滚动条

  if (isShowCrossScrollBar) {
    if (curMaxHeight === curHeight) {// 此处是根据内容来撑开的高度，不用减少
    } else {
      curMaxHeight -= _getScrollbarWidth(); //如果有横向的滚动条，此时正儿八经的内容高度就需要减少滚动条的高度
    }
  }

  var fixedLeft = [];
  var fixedRight = [];
  var noFixed = [];
  columns.forEach(function (column) {
    if (column.fixed === 'left') {
      fixedLeft.push(column);
    } else if (column.fixed === 'right') {
      fixedRight.push(column);
    } else {
      noFixed.push(column);
    }
  });
  var fixedLeftSource = getWidths(fixedLeft, colData);
  var fixedRightSource = getWidths(fixedRight, colData);
  var noFixedSource = getWidths(noFixed, colData);
  return {
    columnsWithHide: columnsWithHide,
    //表头源数据，包括隐藏的表头项
    columns: columns,
    //处理后的表头源数据，给所有项目都添加上了默认宽度，默认宽度是100(默认宽度可以配置，通过itemWidth配置)
    lenAry: getWidths(columns, colData),
    //表头按照合并单元格形式，取出所有项的宽度，需要合并单元格的项，宽度是所有项宽度的总和
    lenRus: sumWidths(getWidths(columns, colData)),
    //表头总宽度
    hierarchy: hierarchy,
    //表头深度
    isShowCrossScrollBar: isShowCrossScrollBar,
    //是否显示横向滚动条
    isShowDirScrollBar: isShowDirScrollBar,
    //是否显示纵向滚动条
    scrollWidth: _getScrollbarWidth(),
    //滚动条宽度
    hierarchyHeight: hierarchyHeight,
    //表头高度
    height: curMaxHeight + (isShowCrossScrollBar ? _getScrollbarWidth() : 0),
    //总高度 => 滚动条 + 中心内容 + 表头 + 底部添加按钮
    boxHeight: curMaxHeight - addBtnHeight,
    //整个表格的高度 => 中心内容 + 表头
    contHeight: curMaxHeight - hierarchyHeight - addBtnHeight - summationHeight,
    //表格内容的高度 => 中心内容
    addBtnHeight: addBtnHeight,
    // 底部栏的高度
    summationHeight: summationHeight,
    // 合计栏高度
    curMaxWidth: curMaxWidth,
    fixedLeft: {
      data: fixedLeft,
      source: fixedLeftSource,
      res: sumWidths(fixedLeftSource)
    },
    fixedRight: {
      data: fixedRight,
      source: fixedRightSource,
      res: sumWidths(fixedRightSource)
    },
    noFixed: {
      data: noFixed,
      source: noFixedSource,
      res: sumWidths(noFixedSource)
    },
    dataSource: dataSource,
    dataSourceHeightInfo: dataSourceHeightInfo,
    isEmptyData: isEmptyData
  };
}; // 辅助线默认样式处理

export var handleLineFn = function handleLineFn(props) {
  var columns = props.columns,
      leftLine = props.leftLine,
      rightLine = props.rightLine,
      moveLine = props.moveLine,
      scrollLeft = props.scrollLeft;

  if (!leftLine.current || !rightLine.current || !moveLine.current) {
    return;
  }

  var fixedLeft = columns.fixedLeft,
      fixedRight = columns.fixedRight,
      isShowCrossScrollBar = columns.isShowCrossScrollBar,
      isShowDirScrollBar = columns.isShowDirScrollBar,
      boxHeight = columns.boxHeight;

  var scrollWidth = _getScrollbarWidth();

  var getAssist = function getAssist(type) {
    return type ? scrollWidth : 0;
  };

  if (isShowCrossScrollBar) {
    if (fixedLeft.res) {
      // 左边的阴影线
      leftLine.current.style.height = "".concat(boxHeight, "px");
      leftLine.current.style.left = "".concat(fixedLeft.res - 10, "px");
      leftLine.current.style.display = scrollLeft > 0 ? 'block' : 'none';
    } else {
      leftLine.current.style.display = 'none';
    }

    if (fixedRight.res) {
      // 右边的阴影线
      rightLine.current.style.height = "".concat(boxHeight, "px");
      rightLine.current.style.right = "".concat(fixedRight.res - 11 + getAssist(isShowDirScrollBar), "px");
      rightLine.current.style.display = 'block';
    } else {
      rightLine.current.style.display = 'none';
    }
  } else {
    leftLine.current.style.display = 'none';
    rightLine.current.style.display = 'none';
  }
}; // 处理辅助线滚动样式

export var handleLineScrollFn = function handleLineScrollFn(props) {
  var leftLine = props.leftLine,
      rightLine = props.rightLine,
      columns = props.columns,
      scrollLeft = props.scrollLeft,
      width = props.width;
  var fixedLeft = columns.fixedLeft,
      fixedRight = columns.fixedRight,
      lenRus = columns.lenRus,
      isShowDirScrollBar = columns.isShowDirScrollBar;
  var scrollWidth = isShowDirScrollBar ? _getScrollbarWidth() : 0;

  if (leftLine.current && fixedLeft.res) {
    var display = leftLine.current.style.display;

    if (scrollLeft === 0 && (!display || display === 'block')) {
      leftLine.current.style.display = 'none';
    } else if (scrollLeft > 0 && (!display || display === 'none')) {
      leftLine.current.style.display = 'block';
    }
  }

  if (rightLine.current && fixedRight.res) {
    var _display = rightLine.current.style.display; // 能执行到这里，肯定有滚动条

    var calRes = lenRus - scrollLeft - width + scrollWidth;
    var calResReg = getNormalDpi() ? 0 : 1;

    if (calRes <= calResReg && (!_display || _display === 'block')) {
      rightLine.current.style.display = 'none';
    } else if (calRes > calResReg && (!_display || _display === 'none')) {
      rightLine.current.style.display = 'block';
    }
  }
}; // 获取颜色配置，蓝色或金色

export var getPrimary = function getPrimary(param) {
  var active = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

  if (active) {
    return "".concat(param, " primaryGold");
  } else {
    return param;
  }
}; // 获取拖拽的最小宽度，最小宽度受表头配置的minWidth影响

export var getMinWidth = function getMinWidth(item) {
  var assistW = 0;
  if (item.sorter) assistW += sorterWidth;
  if (item.fold !== undefined) assistW += foldWidth;
  if (item.iconConfig) assistW += item.iconConfig.width || extraIconWidth;
  if (assistW === 0 && item.info) assistW += infoWidth;
  return Math.max(minItemWidth + assistW, item.minWidth || 0);
}; // 获取设备dpi，适配window电脑的特殊dpi场景，解决横向滚动不能触边，左右固定列不能合理显隐的问题

export var getNormalDpi = function getNormalDpi() {
  var dpi = window.devicePixelRatio; // 获取dpi

  return !(dpi % 0.5);
}; // 数值转换成字母 0 => A; 1 => B; 26 => AA

export var createCellPos = function createCellPos(n) {
  var ordA = 'A'.charCodeAt(0);
  var ordZ = 'Z'.charCodeAt(0);
  var len = ordZ - ordA + 1;
  var s = '';

  while (n >= 0) {
    s = String.fromCharCode(n % len + ordA) + s;
    n = Math.floor(n / len) - 1;
  }

  return s;
};
export var getTargetScrollValue = function getTargetScrollValue(colInfo) {
  var rowKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'id';
  var dataIndex = arguments.length > 2 ? arguments[2] : undefined;
  var rowDataId = arguments.length > 3 ? arguments[3] : undefined;
  var colData = arguments.length > 4 ? arguments[4] : undefined;
  var columns = colInfo.columns,
      dataSource = colInfo.dataSource,
      lenRus = colInfo.lenRus,
      curMaxWidth = colInfo.curMaxWidth,
      dataSourceHeightInfo = colInfo.dataSourceHeightInfo,
      contHeight = colInfo.contHeight,
      fixedLeft = colInfo.fixedLeft;
  var maxScrollLeft = lenRus - curMaxWidth;
  var len = sumWidths(dataSourceHeightInfo);
  var rowHeight = colData.defaultItemHeight;
  var maxHeight = len * rowHeight;
  var maxScrollTop = maxHeight - contHeight;
  var curScrollLeft = 0;
  var leftFlag = false;

  for (var i = 0; i < columns.length; i++) {
    var children = columns[i].children;

    if (children) {
      var flag = false;

      for (var j = 0; j < children.length; j++) {
        if (getKey(children[j]) === dataIndex) {
          flag = true;
          leftFlag = true;
          break;
        }

        curScrollLeft += children[j].width;
      }

      if (flag) {
        break;
      }
    } else {
      if (getKey(columns[i]) === dataIndex) {
        leftFlag = true;
        break;
      }

      curScrollLeft += columns[i].width;
    }
  }

  if (!leftFlag) {
    curScrollLeft = 0;
  } else {
    curScrollLeft -= fixedLeft.res;
  }

  var curScrollTop = 0;
  var topFlag = false;

  for (var _i2 = 0; _i2 < dataSource.length; _i2++) {
    if (getRowKeys(rowKey, dataSource[_i2]) === rowDataId) {
      topFlag = true;
      break;
    }

    curScrollTop += rowHeight;
  }

  if (!topFlag) {
    curScrollTop = 0;
  }

  return [Math.min(maxScrollLeft, curScrollLeft), Math.min(maxScrollTop, curScrollTop)];
};
export var getErrorDisabled = function getErrorDisabled(param, dataIndex, dataRowId) {
  var res = param.find(function (v) {
    if (!v.colId && !v.rowId) {
      return false;
    } else {
      return (v.colId ? v.colId === dataIndex : true) && (v.rowId ? v.rowId === dataRowId : true);
    }
  });
  return res;
};
export var getOneField = function getOneField(columns, dataIndex) {
  var tmp;

  var fn = function fn(columns) {
    columns.forEach(function (v) {
      if (getKey(v) === dataIndex) {
        tmp = v;
      } else if (v.children) {
        fn(v.children);
      }
    });
  };

  fn(columns || []);
  return tmp || {};
};